#ifndef __WLL_API
#define __WLL_API

//- PACKING
#if defined(__BORLANDC__)
  #pragma nopackwarning
  #pragma pack(push,1);
#else
#if defined(__SC__) || defined(__GNUC__) || (defined(__WATCOMC__) && (__WATCOMC__ < 1100))
  #pragma pack(1)
#else
#if defined(_MSC_VER)
  #pragma pack(push,1)
#else
  #pragma pack(__push,1);
#endif
#endif
#endif
//- FAR
#if defined(__USE_FAR_API__)
  #include "plugin.hpp"
#endif
//- TYPES
#if !defined(PCHAR)
  typedef char *PCHAR;
#endif
#if !defined(CONSTSTR)
  typedef const char *CONSTSTR;
#endif
#if !defined(MK_DWORD)
  #define MK_DWORD( lw,hw )  (((((DWORD)hw)&0x0000FFFFUL) << 16) | (((WORD)lw)&0x0000FFFFUL))
#endif
#if !defined(STRUCT)
  #define STRUCT(nm)          typedef struct nm *P##nm; struct nm {
  #define STRUCTBASE(nm,base) typedef struct nm *P##nm; struct nm , base {
#endif

//- WLL STRUCTS
STRUCT( WLLProcs )
   int     (WINAPIV *Sprintf)( char *buffer,CONSTSTR format,... );
   PCHAR   (WINAPI  *Digit2Str)( char *buff,DWORD digit,int radix,int MaxBuffLen );
   DWORD   (WINAPI  *Str2Digit)( CONSTSTR buff,int radix );
   DWORD   (WINAPI  *Str2DigitDetect)( CONSTSTR buff,int DefaultRadix );
};

STRUCT( WLLWindow )
  HWND  Window;
  WORD  Level;
  WORD  Index;
};

#define WLL_PARA_NONE 0
#define WLL_PARA_INT  1
#define WLL_PARA_STR  2

STRUCT( WLLPara )
   BYTE     Type;
   CONSTSTR Name;
   union {
     DWORD    Dword;
     CONSTSTR String;
   } Data;
};

STRUCT( WLLCallInfo )
#if defined(__USE_FAR_API__)            //FAR api
  PluginStartupInfo *Info;
#else
  LPVOID       Info;
#endif
  PWLLProcs    WLLInfo;
  HANDLE       PanelPluginHandle;       //Current panel plugin
  PWLLWindow   Windows;                 //Current windows list
  DWORD        WindowsCount;
  HWND         Window;                  //Called window item
  PWLLPara     Params;                  //Call parameters
  DWORD        ParamCount;
  LPDWORD      Result;                  //Return result
  LPDWORD      Error;                   //Return error
};

typedef BOOL (WINAPI *WLLCallback)( PWLLCallInfo CallInfo );

STRUCT( WLLProcedure )
   CONSTSTR     Name;
   CONSTSTR     Description;
   PWLLPara     Params;
   DWORD        ParaCount;
   WLLCallback  Procedure;
};

#define WLL_CURRENTVERSION MK_DWORD( sizeof(WLLProcs),sizeof(WLLCallInfo) )
STRUCT( WLLLibraryInfo )
   DWORD           VersionRequired;
   PWLLProcedure   Procedures;
   DWORD           ProcCount;
};

typedef PWLLLibraryInfo (WINAPI *WLLQueryLibInfoProc)( void );
#define WLL_QUERYINFOPROC "QueryWLL"

//- PACKING
#if defined(__BORLANDC__)
  #pragma nopackwarning
  #pragma pack(pop)
#else
#if defined(__SC__) || defined(__GNUC__) || (defined(__WATCOMC__) && (__WATCOMC__ < 1100))
  #pragma pack()
#else
#if defined(_MSC_VER)
  #pragma pack(pop)
#else
  #pragma pack(__pop)
#endif
#endif
#endif

#endif