#include "stdafx.h"
#include "history.hpp"
#include "wll_spy.hpp"
#include "far.hpp"
#include "dialog.hpp"
#include "standart.hpp"
#include "options.hpp"
#include "msg.hpp"

CActionsHistory::CActionsHistory()
{
  ItemsCount = 0;
}

CActionsHistory::~CActionsHistory()
{
  return;
}

void CActionsHistory::Add(HANDLE hDlg, HWND hwnd, WindowActions action)
{
  struct FarListInsert newItem;
  FarListItemData newItemData;
  struct SpyWindowInfo windowInfo;

  newItemData.Index = 0;
  newItemData.DataSize = sizeof(DWORD);
  newItemData.Data = (void*)(DWORD)hwnd;
  newItemData.Reserved = 0;

  theSpyWindows->GetWindowInfo(hwnd, &windowInfo);

  newItem.Index = 0;
  newItem.Item.Flags = 0;
  
  static int ActionHelpID[WA_LAST] = {
    actionShow, actionHide, actionRestore, 
    actionMinimize, actionMaximize,
    actionEnable, actionDisable, 
    MClose, actionDestroy
  };

  char buf[MAXSIZE];
  
  lstrcpyn(buf, GetItemName(ActionHelpID[action]), sizeof(buf));

  wsprintf(buf, "%-12s", buf);
  StringReplace(buf, "&", "", sizeof(buf));

  char buf2[MAXSIZE];
  if (theSpyWindows->GetFormatString(windowInfo.hwnd, 
    theOptions->Value(opt_HistoryItemFormat)->StrValue, buf2, sizeof(buf2)))
  {
    lstrcat(buf, buf2);

    lstrcpyn(newItem.Item.Text, buf, sizeof(buf));

    int res = Info.SendDlgMessage(hDlg, DM_LISTINSERT, cbHistory, (long)&newItem);
    if (res != -1)
      Info.SendDlgMessage(hDlg, DM_LISTSETDATA, cbHistory, (long)&newItemData);
  }
}

HWND CActionsHistory::GetHWND(HANDLE hDlg)
{
  HWND hwnd = NULL;
  struct FarListInfo listInfo;

  if (Info.SendDlgMessage(hDlg, DM_LISTINFO, cbHistory, (long)&listInfo))
  {
    hwnd = (HWND)Info.SendDlgMessage(hDlg, DM_LISTGETDATA, cbHistory, listInfo.SelectPos);
  }

  return hwnd;
}
