#ifndef __OPTIONS_HPP__
#define __OPTIONS_HPP__

#define CFGID(item) (item - staticCfgDlgBox)
#define CFGITEM(item) (item + staticCfgDlgBox)

typedef enum {
  OPT_BOOL,
  OPT_INT,
  OPT_STR
} OptionType;

#define OPT_NAME_SIZE (32)
#define OPT_VALUE_SIZE (32)

struct OptionItem
{
  OptionType type;
  int dialogID;
  char *name;//[OPT_NAME_SIZE];
  
  char StrValue[OPT_VALUE_SIZE];
  int  IntValue;

  char *StrValueDef;//[OPT_VALUE_SIZE];
  int  IntValueDef;
};

typedef enum tagEnumOptionsList{
  opt_MainDlgWidth,
  opt_PluginPrefix,

  opt_WLShowHidden,

  opt_ALSmartSelect,
  opt_ALSmartEnable,
  
  opt_SwitchToProcessWnd,

  opt_FilterCaseSensitive,

  opt_WLItemFormat,
  opt_WLCaptionFormat,
  opt_WLHelpFormat,
  opt_HistoryItemFormat,
  
  opt_last
} EnumOptionsList;

class COptions
{
  private:
    static long WINAPI CfgDlgProc(HANDLE hDlg, int Msg, int Param1, long Param2);

  public:
    COptions(void);
    ~COptions(void);

    const OptionItem* Value(EnumOptionsList option);
    BOOL SetBool(EnumOptionsList option, BOOL value);
    BOOL SetInt(EnumOptionsList option, int value);
    BOOL SetStr(EnumOptionsList option, char *value);
    
    int ShowDialog(void);
    void FillDialog(HANDLE hDlg);

    void Load(BOOL LoadDefaultValues = false);
    void Save(void);
};

#endif /* __OPTIONS_HPP__ */
