#include "stdafx.h"
#include "wll_spy.hpp"
#include "far.hpp"
#include "common.hpp"
#include "dialog.hpp"
#include "wndlist.hpp"
#include "dlgevents.hpp"
#include "msg.hpp"

//#include "..\hook\hook.hpp"

CSpyWindows *theSpyWindows = NULL;
CActionsHistory *theHistory = NULL;
CWindowsHistory *theWindowsHistory = NULL;
COptions *theOptions = NULL;

char PluginRootKey[80];

OPENPLUGIN()
{
  HWND startWindow;

#ifdef WL_SUBPLUGIN
  wsprintf(PluginRootKey, "%s\\%s", "Software\\Far\\Plugins", "Spy");
  Info = *((PluginStartupInfo*)CallInfo->Info);
  startWindow = CallInfo->Window;
#else
  (void) Item;
  (void) OpenFrom;
  startWindow = GetDesktopWindow();
#endif

  theSpyWindows = new CSpyWindows();
  theHistory = new CActionsHistory();
  theWindowsHistory = new CWindowsHistory();

  if (!theOptions)
    theOptions = new COptions();

  theOptions->Load();

  MainDlgParams.width = theOptions->Value(opt_MainDlgWidth)->IntValue;
  MainDlgParams.height = 21;

  theSpyWindows->GetWindowInfo(startWindow, &wndInfo);

  farwnd = (HWND)Info.AdvControl(Info.ModuleNumber, ACTL_GETFARHWND, 0);
  
  struct FarDialogItem DialogItems[mainDlgCount];
  
  int DlgW = 70;
  int DlgH = 21;

  static const struct InitDialogItem InitItems [] = {
    DI_DOUBLEBOX,     0,       0,        DlgW-1, DlgH-4,  0, staticDialogBox,
    DI_TEXT,          2,       0,             4,      0,  0, laCloseDialog,
      
    DI_TEXT,          2,       1,             0,      0,  0, laWindowsList,
    DI_COMBOBOX,     13,       1,        DlgW-4,      0,  0, -1,
    DI_EDIT,         13,       1,        DlgW-3,      0,  DIF_READONLY, -1,

    DI_TEXT,          2,       2,             0,      0,  0, laHistory,
    DI_COMBOBOX,     13,       2,        DlgW-3,      0,  DIF_DROPDOWNLIST, -1,

    DI_SINGLEBOX,     1,       3,        DlgW-2,      3,  0, -1,
    
    DI_LISTBOX,       1,       4,            16,     14,  DIF_LISTNOAMPERSAND | DIF_LISTNOBOX, -1,
    DI_SINGLEBOX,    17,       4,            17, DlgH-7,  0, -1,
    
    DI_TEXT,         19,       4,            30,      0,  0, laHandle,
    DI_COMBOBOX,     32,       4,            40,      0,  DIF_DROPDOWNLIST|DIF_LISTNOAMPERSAND, -1,
    DI_BUTTON,       43,       4,             0,      0,  DIF_NOBRACKETS, btnWindowPrev,
    DI_BUTTON,       53,       4,             0,      0,  DIF_NOBRACKETS, btnWindowSucc,
    
    DI_TEXT,         19,       5,            30,      0,  0, laClass,
    DI_EDIT,         32,       5,        DlgW-3,      0,  0, -1,

    DI_TEXT,         19,       6,            30,      0,  0, laText,
    DI_EDIT,         32,       6,        DlgW-3,      0,  0, -1,
    
    DI_TEXT,         19,       7,            30,      0,  0, laRect,
    DI_COMBOBOX,     32,       7,        DlgW-3,      0,  DIF_DROPDOWNLIST, -1,
    
    DI_TEXT,         19,       8,            30,      0,  0, laClassStyle,
    DI_COMBOBOX,     32,       8,            40,      0,  DIF_DROPDOWNLIST, -1,
    
    DI_TEXT,         19,       9,            30,      0,  0, laStyle,
    DI_COMBOBOX,     32,       9,            40,      0,  DIF_DROPDOWNLIST, -1,
    
    DI_TEXT,         19,      10,            30,      0,  0, laExStyle,
    DI_COMBOBOX,     32,      10,            40,      0,  DIF_DROPDOWNLIST, -1,
    
    DI_TEXT,         19,      11,            30,      0,  0, laThreadID,
    DI_FIXEDIT,      32,      11,            40,      0,  0, -1,
    
    DI_TEXT,         19,      12,            30,      0,  0, laProcessID,
    DI_FIXEDIT,      32,      12,            40,      0,  0, -1,

    DI_BUTTON,       19,  DlgH-7,             0,      0,  0, btnFilterSet,
    DI_CHECKBOX,     32,  DlgH-7,             0,      0,  0, cbUseFilter,

    DI_SINGLEBOX,     1,  DlgH-6,        DlgW-2, DlgH-6,  0, -1,

    DI_BUTTON,        0,  DlgH-5,             0,      0,  DIF_CENTERGROUP, btnFindWindow,
    DI_BUTTON,        0,  DlgH-5,             0,      0,  DIF_CENTERGROUP, btnBlinkWindow,
    DI_BUTTON,        0,  DlgH-5,             0,      0,  DIF_CENTERGROUP, btnWLRefresh,
    DI_BUTTON,        0,  DlgH-5,             0,      0,  DIF_CENTERGROUP, btnCloseDialog,
    
    DI_SINGLEBOX,     0,  DlgH-3,        DlgW-1, DlgH-1,  0, staticHelpBox,
    DI_TEXT,          1,  DlgH-2,        DlgW-2,      0,  DIF_SHOWAMPERSAND, -1,
  };
  InitDialogItems(InitItems, DialogItems, sizeof(InitItems) / sizeof(InitItems[0]));
  
  int i;

  ListItems = new FarListItem[lbActionsNumber];
  List.ItemsNumber = lbActionsNumber;
  List.Items = ListItems;

  // DI_LISTBOX " "
  for (i = lbActionsFirst; i <= lbActionsLast; i++)
  {
    if (lstrcmp(GetItemName(i), "-") == 0)
    {
      ListItems[i - lbActionsFirst].Flags = MIF_SEPARATOR;
      lstrcpy(ListItems[i - lbActionsFirst].Text, "");
    }
    else
    {
      ListItems[i - lbActionsFirst].Flags = 0;
      lstrcpy(ListItems[i - lbActionsFirst].Text, GetItemName(i));
    }
  }

  // X2      
  for (i = 0 ; i < sizeof(WidthDependent) / sizeof(WidthDependent[0]); i++)
  {
    DialogItems[WidthDependent[i]].X2 += 
      (theOptions->Value(opt_MainDlgWidth)->IntValue - DlgW);
  }
  
  //   
  Info.DialogEx(Info.ModuleNumber, 
    -1, -1, 
    theOptions->Value(opt_MainDlgWidth)->IntValue, DlgH,
    NULL, DialogItems,
    sizeof(DialogItems) / sizeof(DialogItems[0]),
    0, 0, DlgProc, 0);
  
  //  
  delete theSpyWindows;
  theSpyWindows = NULL;
  delete theHistory;
  theHistory = NULL;
  delete theWindowsHistory;
  theWindowsHistory = NULL;
  delete theOptions;
  theOptions = NULL;

#ifdef WL_SUBPLUGIN
  *CallInfo->Result = 0;
  return TRUE;
#else
  return INVALID_HANDLE_VALUE;
#endif
}

#ifdef WL_SUBPLUGIN
WLLProcedure WLLLibProcs[] = {
  { "Window Action", "Window action", NULL, 0, DoWindowAction }
};

static WLLLibraryInfo WLLInfo = { WLL_CURRENTVERSION, WLLLibProcs, sizeof(WLLLibProcs)/sizeof(WLLLibProcs[0]) };

PWLLLibraryInfo WINAPI QueryWLL(void)
{
  return &WLLInfo;
}
#else
void WINAPI _export GetPluginInfo(struct PluginInfo *Info)
{
  Info->StructSize = sizeof(struct PluginInfo);

  static char *PluginMenuStrings[1];
  PluginMenuStrings[0] = (char*)GetMsg(MPluginMenuStr);
  Info->PluginMenuStrings = PluginMenuStrings;
  Info->PluginMenuStringsNumber = sizeof(PluginMenuStrings) / sizeof(PluginMenuStrings[0]);

  static char *PluginCfgStrings[1];
  PluginCfgStrings[0] = (char*)GetMsg(MPluginCfgStr);
  Info->PluginConfigStrings = PluginCfgStrings;
  Info->PluginConfigStringsNumber = sizeof(PluginCfgStrings) / sizeof(PluginCfgStrings[0]);

  COptions *hOptions = new COptions();
  hOptions->Load();
  Info->CommandPrefix = hOptions->Value(opt_PluginPrefix)->StrValue;
  delete hOptions;
}

void WINAPI _export SetStartupInfo(const struct PluginStartupInfo *pInfo)
{
  Info = *pInfo;

  FSF = *pInfo->FSF;
  Info.FSF = &FSF;

  wsprintf(PluginRootKey, "%s\\%s", pInfo->RootKey, "Spy");
}

int WINAPI _export Configure(int ItemNumber)
{
  (void)ItemNumber;

  if (!theOptions)
    theOptions = new COptions();

  return (theOptions->ShowDialog());
}

int WINAPI _export GetMinFarVersion(void)
{
  //  FAR`     
  return (MAKEFARVERSION(1,70,1906));
}

void WINAPI ExitFAR(void)
{

}

#endif
